summaryrefslogtreecommitdiffstats
diff options
context:
space:
mode:
author B. Watson <yalhcru@gmail.com>2014-10-23 22:54:06 +0700
committer Willy Sudiarto Raharjo <willysr@slackbuilds.org>2014-10-23 22:54:06 +0700
commitc9ab166d6f0da1a5881c7c985569f35c7e84b32b (patch)
tree90745f6389b2429ede2025f061540e38b704994f
parentac74b4bd4131c7be17a80cad5b7c01b9f92f669b (diff)
downloadslackbuilds-c9ab166d6f0da1a5881c7c985569f35c7e84b32b.tar.gz
slackbuilds-c9ab166d6f0da1a5881c7c985569f35c7e84b32b.tar.xz
development/obcpl: Added (BCPL compiler).
Signed-off-by: Willy Sudiarto Raharjo <willysr@slackbuilds.org>
-rw-r--r--development/obcpl/README14
-rw-r--r--development/obcpl/obcpl.SlackBuild100
-rw-r--r--development/obcpl/obcpl.info10
-rw-r--r--development/obcpl/slack-desc19
4 files changed, 143 insertions, 0 deletions
diff --git a/development/obcpl/README b/development/obcpl/README
new file mode 100644
index 0000000000..0549dd6812
--- /dev/null
+++ b/development/obcpl/README
@@ -0,0 +1,14 @@
+obcpl (BCPL compiler)
+
+This is an x86 (IA-32) port of the "classic" old BCPL compiler (around
+1980) from the Tripos Research Group at Cambridge University.
+
+As a real, working computer language implementation, that can be studied,
+modified, and played with, this old BCPL compiler has a good deal to
+recommend it. The compiler frontend consists of only about 2000 lines
+of BCPL code, and (as supplied here) compiles to a static (fully-linked)
+x86 binary that is less than 36000 bytes in size.
+
+x86_64 note: obcpl doesn't require multilib on Slackware64. It only
+generates 32-bit x86 code, but the binaries it creates are 100% statically
+linked, and will run fine on Slackware64 without multlib.
diff --git a/development/obcpl/obcpl.SlackBuild b/development/obcpl/obcpl.SlackBuild
new file mode 100644
index 0000000000..b7fcd57a12
--- /dev/null
+++ b/development/obcpl/obcpl.SlackBuild
@@ -0,0 +1,100 @@
+#!/bin/sh
+
+# Slackware build script for obcpl
+
+# Written by B. Watson (yalhcru@gmail.com)
+
+# Licensed under the WTFPL. See http://www.wtfpl.net/txt/copying/ for details.
+
+PRGNAM=obcpl
+VERSION=${VERSION:-0.9.8}
+BUILD=${BUILD:-1}
+TAG=${TAG:-_SBo}
+
+if [ -z "$ARCH" ]; then
+ case "$( uname -m )" in
+ i?86) ARCH=i486 ;;
+ arm*) ARCH=arm ;;
+ *) ARCH=$( uname -m ) ;;
+ esac
+fi
+
+CWD=$(pwd)
+TMP=${TMP:-/tmp/SBo}
+PKG=$TMP/package-$PRGNAM
+OUTPUT=${OUTPUT:-/tmp}
+
+if [ "$ARCH" = "i486" ]; then
+ SLKCFLAGS="-O2 -march=i486 -mtune=i686"
+ LIBDIRSUFFIX=""
+elif [ "$ARCH" = "i686" ]; then
+ SLKCFLAGS="-O2 -march=i686 -mtune=i686"
+ LIBDIRSUFFIX=""
+elif [ "$ARCH" = "x86_64" ]; then
+ SLKCFLAGS="-O2 -fPIC"
+ LIBDIRSUFFIX="64"
+else
+ SLKCFLAGS="-O2"
+ LIBDIRSUFFIX=""
+fi
+
+set -e
+
+rm -rf $PKG
+mkdir -p $TMP $PKG $OUTPUT
+cd $TMP
+rm -rf $PRGNAM-$VERSION
+tar xvf $CWD/$PRGNAM-$VERSION.tar.xz
+cd $PRGNAM-$VERSION
+chown -R root:root .
+find -L . \
+ \( -perm 777 -o -perm 775 -o -perm 750 -o -perm 711 -o -perm 555 \
+ -o -perm 511 \) -exec chmod 755 {} \; -o \
+ \( -perm 666 -o -perm 664 -o -perm 640 -o -perm 600 -o -perm 444 \
+ -o -perm 440 -o -perm 400 \) -exec chmod 644 {} \;
+
+cd src
+ln -s sys_linux.s sys.s
+
+sed -i \
+ -e 's,/usr/local,/usr,g' \
+ -e "s,\<lib/$PRGNAM,lib$LIBDIRSUFFIX/$PRGNAM,g" \
+ *
+
+make CFLAGS="$SLKCFLAGS" PREFIX="/usr"
+
+# Not quite ready to install: the PREFIX override doesn't entirely work
+# because the st binary was built from st.O (obcpl's parsed syntax tree
+# format) which has the /usr/local/lib path baked into it (not affected
+# by the sed command, above). It's distributed this way because obcpl
+# needs to be buildable on a system without an existing BCPL compiler. So
+# we need to regenerate st.O from st.b (its BCPL source), then rebuild
+# st from st.O. This works because st will look for its includes in the
+# current dir first. This is the sort of thing gcc has 'make bootstrap'
+# for...
+
+rm -f st.O
+./st < st.b > st.O
+rm -f st st.s st.o
+make st
+
+# Now we're good to go.
+make PREFIX="$PKG/usr" install
+
+cd -
+
+gzip $PKG/usr/man/man1/$PRGNAM.1
+
+# Use a symlink instead of a hard link here:
+rm -f $PKG/usr/lib$LIBDIRSUFFIX/$PRGNAM/libhdr
+ln -s LIBHDR $PKG/usr/lib$LIBDIRSUFFIX/$PRGNAM/libhdr
+
+mkdir -p $PKG/usr/doc/$PRGNAM-$VERSION
+cp -a doc/*.txt util $PKG/usr/doc/$PRGNAM-$VERSION
+cat $CWD/$PRGNAM.SlackBuild > $PKG/usr/doc/$PRGNAM-$VERSION/$PRGNAM.SlackBuild
+
+mkdir -p $PKG/install
+cat $CWD/slack-desc > $PKG/install/slack-desc
+
+cd $PKG
+/sbin/makepkg -l y -c n $OUTPUT/$PRGNAM-$VERSION-$ARCH-$BUILD$TAG.${PKGTYPE:-tgz}
diff --git a/development/obcpl/obcpl.info b/development/obcpl/obcpl.info
new file mode 100644
index 0000000000..f27fd4eadd
--- /dev/null
+++ b/development/obcpl/obcpl.info
@@ -0,0 +1,10 @@
+PRGNAM="obcpl"
+VERSION="0.9.8"
+HOMEPAGE="http://www.nordier.com/software/obcpl.html"
+DOWNLOAD="http://www.nordier.com/software/distfiles/obcpl-0.9.8.tar.xz"
+MD5SUM="170223f85130c9b7f54082481a492045"
+DOWNLOAD_x86_64=""
+MD5SUM_x86_64=""
+REQUIRES=""
+MAINTAINER="B. Watson"
+EMAIL="yalhcru@gmail.com"
diff --git a/development/obcpl/slack-desc b/development/obcpl/slack-desc
new file mode 100644
index 0000000000..672c7e2784
--- /dev/null
+++ b/development/obcpl/slack-desc
@@ -0,0 +1,19 @@
+# HOW TO EDIT THIS FILE:
+# The "handy ruler" below makes it easier to edit a package description.
+# Line up the first '|' above the ':' following the base package name, and
+# the '|' on the right side marks the last column you can put a character in.
+# You must make exactly 11 lines for the formatting to be correct. It's also
+# customary to leave one space after the ':' except on otherwise blank lines.
+
+ |-----handy-ruler------------------------------------------------------|
+obcpl: obcpl (BCPL compiler)
+obcpl:
+obcpl: This is an x86 (IA-32) port of the "classic" old BCPL compiler
+obcpl: (around 1980) from the Tripos Research Group at Cambridge University.
+obcpl:
+obcpl:
+obcpl:
+obcpl:
+obcpl:
+obcpl:
+obcpl: